summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
-rw-r--r--tools/testing/selftests/bpf/config1
-rwxr-xr-xtools/testing/selftests/bpf/ima_setup.sh107
2 files changed, 64 insertions, 44 deletions
diff --git a/tools/testing/selftests/bpf/config b/tools/testing/selftests/bpf/config
index 365bf9771b07..37e1f303fc11 100644
--- a/tools/testing/selftests/bpf/config
+++ b/tools/testing/selftests/bpf/config
@@ -43,3 +43,4 @@ CONFIG_IMA=y
CONFIG_SECURITYFS=y
CONFIG_IMA_WRITE_POLICY=y
CONFIG_IMA_READ_POLICY=y
+CONFIG_BLK_DEV_LOOP=y
diff --git a/tools/testing/selftests/bpf/ima_setup.sh b/tools/testing/selftests/bpf/ima_setup.sh
index 15490ccc5e55..2bfc646bc230 100755
--- a/tools/testing/selftests/bpf/ima_setup.sh
+++ b/tools/testing/selftests/bpf/ima_setup.sh
@@ -3,78 +3,97 @@
set -e
set -u
+set -o pipefail
IMA_POLICY_FILE="/sys/kernel/security/ima/policy"
TEST_BINARY="/bin/true"
usage()
{
- echo "Usage: $0 <setup|cleanup|run> <existing_tmp_dir>"
- exit 1
+ echo "Usage: $0 <setup|cleanup|run> <existing_tmp_dir>"
+ exit 1
+}
+
+ensure_mount_securityfs()
+{
+ local securityfs_dir=$(grep "securityfs" /proc/mounts | awk '{print $2}')
+
+ if [ -z "${securityfs_dir}" ]; then
+ securityfs_dir=/sys/kernel/security
+ mount -t securityfs security "${securityfs_dir}"
+ fi
+
+ if [ ! -d "${securityfs_dir}" ]; then
+ echo "${securityfs_dir}: securityfs is not mounted" && exit 1
+ fi
}
setup()
{
- local tmp_dir="$1"
- local mount_img="${tmp_dir}/test.img"
- local mount_dir="${tmp_dir}/mnt"
- local copied_bin_path="${mount_dir}/$(basename ${TEST_BINARY})"
- mkdir -p ${mount_dir}
+ local tmp_dir="$1"
+ local mount_img="${tmp_dir}/test.img"
+ local mount_dir="${tmp_dir}/mnt"
+ local copied_bin_path="${mount_dir}/$(basename ${TEST_BINARY})"
+ mkdir -p ${mount_dir}
+
+ dd if=/dev/zero of="${mount_img}" bs=1M count=10
- dd if=/dev/zero of="${mount_img}" bs=1M count=10
+ losetup -f "${mount_img}"
+ local loop_device=$(losetup -a | grep ${mount_img:?} | cut -d ":" -f1)
- local loop_device="$(losetup --find --show ${mount_img})"
+ mkfs.ext2 "${loop_device:?}"
+ mount "${loop_device}" "${mount_dir}"
- mkfs.ext4 "${loop_device}"
- mount "${loop_device}" "${mount_dir}"
+ cp "${TEST_BINARY}" "${mount_dir}"
+ local mount_uuid="$(blkid ${loop_device} | sed 's/.*UUID="\([^"]*\)".*/\1/')"
- cp "${TEST_BINARY}" "${mount_dir}"
- local mount_uuid="$(blkid -s UUID -o value ${loop_device})"
- echo "measure func=BPRM_CHECK fsuuid=${mount_uuid}" > ${IMA_POLICY_FILE}
+ ensure_mount_securityfs
+ echo "measure func=BPRM_CHECK fsuuid=${mount_uuid}" > ${IMA_POLICY_FILE}
}
cleanup() {
- local tmp_dir="$1"
- local mount_img="${tmp_dir}/test.img"
- local mount_dir="${tmp_dir}/mnt"
+ local tmp_dir="$1"
+ local mount_img="${tmp_dir}/test.img"
+ local mount_dir="${tmp_dir}/mnt"
+
+ local loop_devices=$(losetup -a | grep ${mount_img:?} | cut -d ":" -f1)
- local loop_devices=$(losetup -j ${mount_img} -O NAME --noheadings)
- for loop_dev in "${loop_devices}"; do
- losetup -d $loop_dev
- done
+ for loop_dev in "${loop_devices}"; do
+ losetup -d $loop_dev
+ done
- umount ${mount_dir}
- rm -rf ${tmp_dir}
+ umount ${mount_dir}
+ rm -rf ${tmp_dir}
}
run()
{
- local tmp_dir="$1"
- local mount_dir="${tmp_dir}/mnt"
- local copied_bin_path="${mount_dir}/$(basename ${TEST_BINARY})"
+ local tmp_dir="$1"
+ local mount_dir="${tmp_dir}/mnt"
+ local copied_bin_path="${mount_dir}/$(basename ${TEST_BINARY})"
- exec "${copied_bin_path}"
+ exec "${copied_bin_path}"
}
main()
{
- [[ $# -ne 2 ]] && usage
-
- local action="$1"
- local tmp_dir="$2"
-
- [[ ! -d "${tmp_dir}" ]] && echo "Directory ${tmp_dir} doesn't exist" && exit 1
-
- if [[ "${action}" == "setup" ]]; then
- setup "${tmp_dir}"
- elif [[ "${action}" == "cleanup" ]]; then
- cleanup "${tmp_dir}"
- elif [[ "${action}" == "run" ]]; then
- run "${tmp_dir}"
- else
- echo "Unknown action: ${action}"
- exit 1
- fi
+ [[ $# -ne 2 ]] && usage
+
+ local action="$1"
+ local tmp_dir="$2"
+
+ [[ ! -d "${tmp_dir}" ]] && echo "Directory ${tmp_dir} doesn't exist" && exit 1
+
+ if [[ "${action}" == "setup" ]]; then
+ setup "${tmp_dir}"
+ elif [[ "${action}" == "cleanup" ]]; then
+ cleanup "${tmp_dir}"
+ elif [[ "${action}" == "run" ]]; then
+ run "${tmp_dir}"
+ else
+ echo "Unknown action: ${action}"
+ exit 1
+ fi
}
main "$@"